/**
 * StreitgenossenGesamtschuldExtractAction.java
 * eu.gronos.kostenrechner.view.panel (Kostenrechner)
 */
package eu.gronos.kostenrechner.controller.baumbach;

import java.awt.event.ActionEvent;
import java.awt.event.KeyEvent;

import eu.gronos.kostenrechner.controller.BeschriebeneAktion;
import eu.gronos.kostenrechner.model.baumbach.BaumbachBeteiligtenListe;
import eu.gronos.kostenrechner.model.baumbach.BaumbachGesamtschuldnerschaft;
import eu.gronos.kostenrechner.model.baumbach.BeteiligtenTableModel;
import eu.gronos.kostenrechner.view.baumbach.StreitgenossenPanel;

/**
 * Der AbstractAction mit dem Namen gesamtschuldnerschaftExtrahieren geht nach
 * Beteiligtentypen aufgeteilt durch die Beteiligten einer Tabelle, bestimmt den
 * gesamtschuldnerischen Sockelbetrag bestimmen, erzeugt dann
 * BaumbachGesamtschuldner und zieht von allen Beteiligten diesen Sockelbetrag
 * ab. {@link KeyEvent#VK_V}
 *
 * @author Peter Schuster (setrok)
 * @date 10.11.2018
 *
 */
public class StreitgenossenGesamtschuldBkExtractAction extends BeschriebeneAktion {
	/**
	 * panel speichert TODO (kommentieren) als StreitgenossenGesamtschuldExtractAction.
	 */
	private final StreitgenossenPanel panel;
	private static final long serialVersionUID = -2835734772816646654L;

	/**
	 * Konstruktor: TODO  (kommentieren) 
	 * 
	 * @param name
	 * @param shortDescription
	 * @param mnemonic
	 * @param actionCommandKey
	 * @param panel TODO
	 */
	public StreitgenossenGesamtschuldBkExtractAction(StreitgenossenPanel panel, String name, String shortDescription, int mnemonic,
			String actionCommandKey) {
		super(name, shortDescription, mnemonic, actionCommandKey);
		this.panel = panel;
	}

	@Override
	public void actionPerformed(ActionEvent e) {
		BeteiligtenTableModel btm = panel.btmBeklagte;
		// TODO ALLES PRÜFEN!
		BaumbachBeteiligtenListe beteiligte = btm.getAllValues();
		if (beteiligte == null || beteiligte.size() < 2)
			return;
		BaumbachGesamtschuldnerschaft gesamtschuldnerschaft = beteiligte
				.extrahiereGesamtschuldnerschaft(btm.getBeteiligtenTyp());
		if (gesamtschuldnerschaft != null) {
			btm.addRow(gesamtschuldnerschaft);
			// Rekursion, sofern Rückgabe nicht null
			actionPerformed(e);
			// Und das Model muss was von der Änderung mitbekommen.
			btm.fireTableDataChanged();
		}
	}
}