/**
 * StreitgenossenGesamtschuldDwbkExtractAction.java
 * eu.gronos.kostenrechner.view.panel (Kostenrechner)
 */
package eu.gronos.kostenrechner.controller.baumbach;

import java.awt.event.ActionEvent;
import java.awt.event.KeyEvent;

import eu.gronos.kostenrechner.Kostenrechner;
import eu.gronos.kostenrechner.controller.BeschriebeneAktion;
import eu.gronos.kostenrechner.model.baumbach.BaumbachBeteiligtenListe;
import eu.gronos.kostenrechner.model.baumbach.BaumbachGesamtschuldnerschaft;
import eu.gronos.kostenrechner.view.baumbach.StreitgenossenPanel;

/**
 * Der AbstractAction mit dem Namen gesamtschuldnerschaftDwbkExtrahieren geht
 * die Beteiligten einer Seite durch und guckt, ob sie z.T. gesamtschuldnerisch
 * verurteilt wurden. {@link KeyEvent#VK_W}
 *
 * @author Peter Schuster (setrok)
 * @version
 * @date 10.11.2018
 *
 */
public class StreitgenossenGesamtschuldDwbkExtractAction extends BeschriebeneAktion {
	/**
	 * panel speichert TODO (kommentieren) als StreitgenossenGesamtschuldDwbkExtractAction.
	 */
	private final StreitgenossenPanel panel;
	private static final long serialVersionUID = 8105321861085009090L;

	/**
	 * Konstruktor: TODO  (kommentieren) 
	 * 
	 * @param name
	 * @param shortDescription
	 * @param mnemonic
	 * @param actionCommandKey
	 * @param panel TODO
	 */
	public StreitgenossenGesamtschuldDwbkExtractAction(StreitgenossenPanel panel, String name, String shortDescription, int mnemonic,
			String actionCommandKey) {
		super(name, shortDescription, mnemonic, actionCommandKey);
		this.panel = panel;
	}

	@Override
	public void actionPerformed(ActionEvent e) {
		// TODO ALLES PRÜFEN!
		// WICHTIG: Vorher echte Kopie anlegen!
		BaumbachBeteiligtenListe beteiligte = new BaumbachBeteiligtenListe();
		beteiligte.addAll(panel.btmKlaeger.getAllValues());
		beteiligte.addAll(panel.btmDrittwiderbeklagte.getAllValues());
		if (beteiligte == null || beteiligte.size() < 2)
			return;
		BaumbachGesamtschuldnerschaft gesamtschuldnerschaft = beteiligte
				.extrahiereGesamtschuldnerschaft(panel.btmDrittwiderbeklagte.getBeteiligtenTyp());
		if (gesamtschuldnerschaft != null) {
			panel.btmDrittwiderbeklagte.addRow(gesamtschuldnerschaft);
			// System.out.println
			Kostenrechner.getLogger().info("Schleife");
			// Rekursion, sofern Rückgabe nicht null: Bei Dwbk nicht gut...
			actionPerformed(e);
			// Und das Model muss was von der Änderung mitbekommen.
			panel.btmKlaeger.fireTableDataChanged();
			panel.btmDrittwiderbeklagte.fireTableDataChanged();
		}
	}
}