/**
 * LadeSkktx.java
 * eu.gronos.kostenrechner.view (Kostenrechner)
 */
package eu.gronos.kostenrechner.controller.files;

import java.awt.event.ActionEvent;

import javax.swing.KeyStroke;

import eu.gronos.kostenrechner.controller.BeschriebeneAktion;
import eu.gronos.kostenrechner.controller.VerfahrensDatenContainer;
import eu.gronos.kostenrechner.view.BerechnungLadenSpeichernDialog;
import eu.gronos.kostenrechner.view.DateiJMenu;

/**
 * Lädt die Daten aller Registerkarten aus einer früher gespeicherten Berechnung
 * (Strg+O)
 *
 * @author Peter Schuster (setrok)
 * @date 11 Nov 2018
 *
 */
public class LadeSkktxAction extends BeschriebeneAktion {
	private final DateiJMenu menu;
	private static final long serialVersionUID = -2225698692818848010L;

	/**
	 * Konstruktor: TODO (kommentieren)
	 * 
	 * @param name
	 * @param shortDescription
	 * @param mnemonic
	 * @param actionCommandKey
	 * @param acceleratorKey
	 * @param menu             TODO
	 */
	public LadeSkktxAction(DateiJMenu menu, String name, String shortDescription, int mnemonic, String actionCommandKey,
			KeyStroke acceleratorKey) {
		super(name, shortDescription, mnemonic, actionCommandKey, acceleratorKey);
		this.menu = menu;
	}

	@Override
	public void actionPerformed(ActionEvent ae) {
		final BerechnungLadenSpeichernDialog db = new BerechnungLadenSpeichernDialog();
		final VerfahrensDatenContainer container = db.ladeXmlDialog(this.menu.getKostenrechner());
		if (container != null)
			new VerfahrensDatenContainer2GUI().setzeAlleWerteAusContainer(container);
	}
}