/**
 * RtfFileFilter.java
 * eu.gronos.kostenrechner.view.result (Kostenrechner)
 */
package eu.gronos.kostenrechner.controller.files;

import java.io.File;

import javax.swing.filechooser.FileFilter;

/**
 * FileFilter für RTF-Dateien (und Verzeichnisse)
 *
 * @author Peter Schuster (setrok)
 * @date 25 Nov 2018
 *
 */
public class RtfFileFilter extends FileFilter {
	public static final String RTF_EXTENSION = ".rtf";

	@Override
	public boolean accept(File f) {
		return (f != null && (f.isDirectory() || f.getName().endsWith(RtfFileFilter.RTF_EXTENSION)));
	}

	@Override
	public String getDescription() {
		return "Rich Text Format (RTF)";
	}
}