/**
 * StreitwertReduktionHorcher.java
 * eu.gronos.kostenrechner.view.panel (Kostenrechner)
 */
package eu.gronos.kostenrechner.controller.gebuehren;

import java.awt.event.FocusEvent;
import java.awt.event.FocusListener;

import eu.gronos.kostenrechner.view.gebuehren.TeilklageruecknahmePanel;

/**
 * Soll jede Änderung des niedrigeren Streitwerts nach Letztlich Obsiegt
 * zurückschreiben.
 * 
 * @author Peter Schuster (setrok)
 * @date 27.10.2018
 *
 */
public class StreitwertReduktionHorcher implements FocusListener {
	/**
	 * panel speichert TODO (kommentieren) als StreitwertReduktionHorcher.
	 */
	private TeilklageruecknahmePanel panel;

	/**
	 * Konstruktor: TODO (kommentieren)
	 * 
	 * @param teilklageruecknahmePanel
	 */
	public StreitwertReduktionHorcher(TeilklageruecknahmePanel teilklageruecknahmePanel) {
		panel = teilklageruecknahmePanel;
	}

	private long alterStreitwert = -1;

	/**
	 * Wenn das Textfeld den Focus bekommt: Wert zwischenspeichern, um eine Änderung
	 * erkennen zu können
	 */
	@Override
	public void focusGained(FocusEvent fe) {
		if (panel.getFtfStreitwertNachher() == null)
			return;
		String s = panel.getFtfStreitwertNachher().getText();
		alterStreitwert = -1;
		/* Erst gucken, ob's ein long ist */
		try {
			alterStreitwert = Long.parseLong(s);
		} catch (NumberFormatException nfe) {
			/* Sonst gucken, ob's ein double ist */
			try {
				alterStreitwert = (long) Double.parseDouble(s);
			} catch (NumberFormatException nfe2) {
				alterStreitwert = -1;
			}
		}
	}

	/**
	 * Wenn das Textfeld den Focus verliert: Gucken, ob sich der Wert seit
	 * Focus-Erlangung geändert hat. Wenn ja: auch das letztliche Obsiegen ändern.
	 */
	@Override
	public void focusLost(FocusEvent fe) {
		if (panel.getFtfStreitwertNachher() == null || panel.getFtfObsiegen() == null)
			return;
		long neuerStreitwert = alterStreitwert;
		String s = panel.getFtfStreitwertNachher().getText();
		/* Erst gucken, ob's ein long ist */
		try {
			neuerStreitwert = Long.parseLong(s);
		} catch (NumberFormatException nfe) {
			/* Sonst gucken, ob's ein double ist */
			try {
				neuerStreitwert = (long) Double.parseDouble(s);
			} catch (NumberFormatException nfe2) {
				neuerStreitwert = alterStreitwert;
			}
		}
		if (neuerStreitwert != alterStreitwert) {
			panel.getFtfObsiegen().setText(panel.getFtfStreitwertNachher().getText());
		}
	}
}